<?php
define('WP_INSTALLING', true);
//These two defines are required to allow us to use require_wp_db() to load the database class while being wp-content/wp-db.php aware
define('ABSPATH', dirname(dirname(__FILE__)).'/');
define('WPINC', 'wp-includes');

require_once('../wp-includes/compat.php');
require_once('../wp-includes/functions.php');
require_once('../wp-includes/classes.php');

if (!file_exists('../wp-config-sample.php'))
	wp_die('Извините, мне нужен файл wp-config-sample.php чтобы начать работу. Пожалуйста, перезагрузите этот файл из вашего дистрибутива WordPress.');

$configFile = file('../wp-config-sample.php');

if ( !is_writable('../'))
	wp_die("Извините, я не могу записать в директорию. Вы должны сделать изменения прав в вашей директории WordPress или создайте ваш wp-config.php вручную.");

// Check if wp-config.php has been created
if (file_exists('../wp-config.php'))
	wp_die("<p>Файл 'wp-config.php' уже существует. Если вам нужно сбросить любой из пунктов конфигурацию в этом файле, удалите его для начала.  Вы можете попытаться <a href='install.php'>установить сейчас</a>.</p>");

if (isset($_GET['step']))
	$step = $_GET['step'];
else
	$step = 0;

function display_header(){
	header( 'Content-Type: text/html; charset=utf-8' );
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>WordPress &rsaquo; Setup Configuration File</title>
<link rel="stylesheet" href="<?php echo $admin_dir; ?>css/install.css" type="text/css" />

</head>
<body>
<h1 id="logo"><img alt="WordPress" src="images/wordpress-logo.png" /></h1>
<?php
}//end function display_header();

switch($step) {
	case 0:
		display_header();
?>

<p>Добро пожаловать в WordPress. Перед тем как мы начнем, нам нужно заполнить некоторую информацию о базе данных. Вам необходимо знать следующие вещи, прежде чем продолжить.</p>
<ol>
	<li>Имя базы данных</li>
	<li>Имя пользователя базы данных</li>
	<li>пароль базы данных</li>
	<li>Хост базы данных</li>
	<li>Префикс таблицы (если вы хотите запускать более чем один WordPress в единой базе данных) </li>
</ol>
<p><strong>Если по каким либо причинам автоматическое создание невозможно, не беспокойтесь. Всю информацию о базе данных можно заполнить в конфигурационном файле. Вы можете также просто открыть <code>wp-config-sample.php</code> в текстовом редакторе, корректно работающим с UTF-8 (например UnicEdit), заполнить вашу информацию, и сохранить файл как <code>wp-config.php</code>. </strong></p>
<p>По всей вероятности, эти данные были поставлены Вам по вашим провайдером. Если вы не имеете этой информации, тогда вам нужно связаться с ними прежде чем вы сможете продолжить. Если вы уже готовы, <a href="setup-config.php?step=1">вперед</a>! </p>

<p><a href="setup-config.php?step=1" class="button">Поехали!</a></p>
<?php
	break;

	case 1:
		display_header();
	?>
<form method="post" action="setup-config.php?step=2">
	<p>Ниже Вы должны ввести данные для подключения к базе данных. Если вы не разбираетесь в этом, обратитесь к вашему хостеру. </p>
	<table class="form-table">
		<tr>
			<th scope="row">Имя базы данных</th>
			<td><input name="dbname" type="text" size="25" value="wordpress" /></td>
			<td>Имя базы данных, которую вы хотите использовать для работы с WP. </td>
		</tr>
		<tr>
			<th scope="row">Имя пользователя</th>
			<td><input name="uname" type="text" size="25" value="username" /></td>
			<td>Ваше имя пользователя MySQL</td>
		</tr>
		<tr>
			<th scope="row">Пароль</th>
			<td><input name="pwd" type="text" size="25" value="password" /></td>
			<td>...и MySQL пароль.</td>
		</tr>
		<tr>
			<th scope="row">Хост базы данных</th>
			<td><input name="dbhost" type="text" size="25" value="localhost" /></td>
			<td>в 99% случаях вам не нужно менять это значение.</td>
		</tr>
		<tr>
			<th scope="row">Префикс таблицы</th>
			<td><input name="prefix" type="text" id="prefix" value="wp_" size="25" /></td>
			<td>Если вы хотите запустить несколько инсталляций WordPress в единой базе данных, измените это.</td>
		</tr>
	</table>
	<h2 class="step">
	<input name="submit" type="submit" value="Отправить" class="button" />
	</h2>
</form>
<?php
	break;

	case 2:
	$dbname  = trim($_POST['dbname']);
	$uname   = trim($_POST['uname']);
	$passwrd = trim($_POST['pwd']);
	$dbhost  = trim($_POST['dbhost']);
	$prefix  = trim($_POST['prefix']);
	if (empty($prefix)) $prefix = 'wp_';

	// Test the db connection.
	define('DB_NAME', $dbname);
	define('DB_USER', $uname);
	define('DB_PASSWORD', $passwrd);
	define('DB_HOST', $dbhost);

	// We'll fail here if the values are no good.
	require_wp_db();
	if ( !empty($wpdb->error) )
		wp_die($wpdb->error->get_error_message());

	$handle = fopen('../wp-config.php', 'w');

	foreach ($configFile as $line_num => $line) {
		switch (substr($line,0,16)) {
			case "define('DB_NAME'":
				fwrite($handle, str_replace("putyourdbnamehere", $dbname, $line));
				break;
			case "define('DB_USER'":
				fwrite($handle, str_replace("'usernamehere'", "'$uname'", $line));
				break;
			case "define('DB_PASSW":
				fwrite($handle, str_replace("'yourpasswordhere'", "'$passwrd'", $line));
				break;
			case "define('DB_HOST'":
				fwrite($handle, str_replace("localhost", $dbhost, $line));
				break;
			case '$table_prefix  =':
				fwrite($handle, str_replace('wp_', $prefix, $line));
				break;
			default:
				fwrite($handle, $line);
		}
	}
	fclose($handle);
	chmod('../wp-config.php', 0666);

	display_header();
?>
<p>Все в порядке! Вы выполнили эту части установки. WordPress теперь может общаться с базой данных. Если вы готовы, время приступить к </p>

<p><a href="install.php" class="button">Запуску инсталляции</a></p>
<?php
	break;
}
?>
</body>
</html>
