<?php
/*
Plugin Name: Wordpress to blogger.com (blogspot.com) cross poster
Plugin URI: http://blogclient.ru
Description: Публикация новых статей на вашем зеркале в blogger.com (blogspot.com)
Author: Владимир Юшко (http://blogclient.ru)
Version: 3.0
Author URI: http://blogclient.ru/
*/ 

function BloggercomAddPages() {
	add_options_page("Blogger.com", "Blogger.com", 6, __FILE__, "BloggercomDisplayOptions");
}

function MyGetOptionValue($Name) {
	add_option($Name);
$Result = stripslashes(get_option($Name));
if (isset($_REQUEST[$Name]) && ($Result != $_REQUEST[$Name])) {
			update_option($Name, $_REQUEST[$Name]);
			$Result = $_REQUEST[$Name];
		}
return$Result;
}

function BloggercomDisplayOptions() {
	global $wpdb;
	$BlogspotEmail = MyGetOptionValue("BlogspotEmail");
$BloggercomMore = MyGetOptionValue("BloggercomMore");
if (isset($_REQUEST['BlogspotEmail']) && !isset($_REQUEST['BloggercomMore'])) {
$BloggercomMore = false;
			update_option('BloggercomMore', false);
}
$Checked = $BloggercomMore ? 'checked="checked"' : '';

	echo <<<EOF
		<div style="-moz-border-radius: 10px; padding: 0px 10px 0px 10px; border: 2px solid silver;">
		<form action="" method="POST">
		<br clear="all" />
		Секретный E-Mail адрес на blogspot : <input id="BlogspotEmail" name="BlogspotEmail" type="text" size="80" value="{$BlogspotEmail}" /> 
<label><input id="BloggercomMore" name="BloggercomMore" type="checkbox" value="true" {$Checked} />Публиковать запись полностью</label>
		<br clear="all" />
		<br clear="all" /><br clear="all" />
<input type="submit" name="UPDATE" value="Обновить" style="float: right;">
		</form><br /><br clear="all" /><br clear="all" />
		Примечание: чтобы новые статьи появлялись у вас на blogspot.com из писем вы должны включить соответствующую опцию в контрольной панели на blogspot.com, где и выбрать секретный адрес E-Mail на который будут приходить новые статьи, иначе не указывайте здесь E-Mail.
		</div>
EOF;
}

function CutStr($S, $Chars, $FromPos = 0) {
if (strlen($S) <= $FromPos) return $S;
$p = 0;
for ($i = 0; $i < strlen($Chars); $i++) {
$pos = strpos($S, $Chars[$i], $FromPos);
if (is_int($pos)) {
$p = $i == 0 ? $pos : min($p, $pos);
}
}
return substr($S, 0, max($p, $FromPos) );
}

function  SendEMailToBloggercom($PostId)  {
//prevent double message
	add_option('BloggercomLastPostId');
$LastPostId= stripslashes(get_option('BloggercomLastPostId'));
		if($PostId <= $LastPostId) return $PostId;
update_option('BloggercomLastPostId', $PostId);

	$BlogspotEmail = stripslashes(get_option("BlogspotEmail"));
$BloggercomMore= get_option("BloggercomMore");

	$Post = & get_post($PostId);
$Subject = apply_filters('the_title', $Post->post_title);
$From = get_option('admin_email');
$Date = gmdate ("M d Y H:i:s", time());


$excerpt_length = 40;
$allowed_tags = '<div><img><a><p><br><br /><br/>';
$filter_type='content';
$use_more_link=true;
$more_link_text="Read more | Читать дальше >>";
$force_more=true;
$fakeit=1;
$fix_tags=true;
$no_more=false;
$more_tag='div';
$more_link_title='Continue reading this entry';
$showdots=true;
$filter_type = 'the_' . $filter_type;


	if($fakeit == 2) { // force content as excerpt
		$text = $Post->post_content;
	} elseif($fakeit == 1) { // content as excerpt, if no excerpt
		$text = (empty($Post->post_excerpt)) ? $Post->post_content : $Post->post_excerpt;
	} else { // excerpt no matter what
		$text = $Post->post_excerpt;
	}

	if($excerpt_length < 0) {
		$output = $text;
	} else {
		if(!$no_more && strpos($text, '<!--more-->')) {
		    $text = explode('<!--more-->', $text, 2);
			$l = count($text[0]);
			$more_link = 1;
		} else {
			$text = explode(' ', $text);
			if(count($text) > $excerpt_length) {
				$l = $excerpt_length;
				$ellipsis = 1;
			} else {
				$l = count($text);
				$more_link_text = '';
				$ellipsis = 0;
			}
		}
		for ($i=0; $i<$l; $i++)
				$output .= $text[$i] . ' ';
	}

	


//	$output = str_replace(array("\r\n", "\r", "\n", "  "), " ", $output);

	$output = rtrim($output, "\s\n\t\r\0\x0B");
	
	$output .= ($showdots && $ellipsis) ? '...' : '';

	switch($more_tag) {
		case('div') :
			$tag = 'div';
		break;
		case('span') :
			$tag = 'span';
		break;
		case('p') :
			$tag = 'p';
		break;
		default :
			$tag = 'span';
	}

	if ($use_more_link && $more_link_text) {
		if($force_more) {
			$output .= ' <' . $tag . ' class="more-link"><a href="'. get_permalink($Post->ID) . '" title="' . $more_link_title . '">' . $more_link_text . '</a></' . $tag . '>' . "\n";
		} else {
			$output .= ' <' . $tag . ' class="more-link"><a href="'. get_permalink($Post->ID) . '" title="' . $more_link_title . '">' . $more_link_text . '</a></' . $tag . '>' . "\n";
		}
	}


$Body .= apply_filters('the_content', $output);

$Body .= '<p><a href="'.get_permalink($PostId).'">Здесь можно оставить свои комментарии</a>. 
</p>';
if (!empty($BlogspotEmail)) {
$Subject =  '=?utf-8?B?'.@base64_encode($Subject). '?=';
mail($BlogspotEmail, $Subject, $Body,
"From: $From
Content-Type: text/html; charset=\"UTF-8\"
Content-Transfer-Encoding: 8bit
MIME-Version: 1.0
Date: $Date
Reply-To: $From
X-Priority: 3
X-Mailer: subscribe.ru and blogspot.com cross poster (lavkasnov.com)");
}

return $PostId;
}

add_action('admin_menu', 'BloggercomAddPages');
add_action('publish_post', 'SendEMailToBloggercom');

?>